SHADER version 1
@OpenGL2.Vertex
#version 400
#define MAX_INSTANCES 256

//Uniforms
uniform mat4 projectioncameramatrix;
uniform mat4 camerainversematrix;
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;


//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_tangent;
in vec3 vertex_binormal;

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec4 ex_vertexposition;
out vec4 camerainversepos;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;
	
	ex_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);
	gl_Position = projectioncameramatrix * ex_vertexposition;

	//normals
	mat3 nmat = mat3(entitymatrix_);
	ex_normal = normalize(nmat * vertex_normal);	
	ex_tangent = normalize(nmat * vertex_tangent);
	ex_binormal = normalize(nmat * vertex_binormal);
	
	ex_texcoords0 = vertex_texcoords0;
	
	camerainversepos = camerainversematrix * entitymatrix_ * vec4(vertex_position, 1.0);
}
@OpenGLES2.Vertex

@OpenGLES2.Fragment

@OpenGL4.Vertex
#version 400
#define MAX_INSTANCES 256

//Uniforms
uniform mat4 projectioncameramatrix;
uniform mat4 camerainversematrix;
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;


//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_tangent;
in vec3 vertex_binormal;

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec4 ex_vertexposition;
out vec4 camerainversepos;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;
	
	ex_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);
	gl_Position = projectioncameramatrix * ex_vertexposition;

	//normals
	mat3 nmat = mat3(entitymatrix_);
	ex_normal = normalize(nmat * vertex_normal);	
	ex_tangent = normalize(nmat * vertex_tangent);
	ex_binormal = normalize(nmat * vertex_binormal);
	
	ex_texcoords0 = vertex_texcoords0;
	
	camerainversepos = camerainversematrix * entitymatrix_ * vec4(vertex_position, 1.0);
}
@OpenGL4.Fragment
//from Leadwerks soft particle shader

#version 400

//Variables
vec3 fog_color = vec3(1.0,1.0,1.0);
float fog_brightness = 1.0;
float opacity = 0.7;

//Uniforms
uniform sampler2D texture0;
uniform sampler2D texture1;//normal 
uniform sampler2DMS texture11;//screen depth
uniform vec2 camerarange;
uniform vec2 buffersize;
uniform bool isbackbuffer;
uniform vec3 cameraposition;
uniform float currenttime;
float time = currenttime/1000;

//Inputs
in vec4 camerainversepos;
in vec4 ex_vertexposition;
in vec2 ex_texcoords0;
in vec3 ex_normal;
in vec3 ex_tangent;
in vec3 ex_binormal;

//Outputs
out vec4 fragData0;
out vec4 fragData1;

float depthToPosition(in float depth, in vec2 depthrange)
{
	return depthrange.x / (depthrange.y - depth * (depthrange.y - depthrange.x)) * depthrange.y;
}

void main()
{
	//Screen depth
	vec2 fogcoords = gl_FragCoord.xy / buffersize;
	if (isbackbuffer) fogcoords.y = 1.0 - fogcoords.y;
	float fog_backgrounddepth = depthToPosition(texelFetch(texture11,ivec2(fogcoords*buffersize),0).r,camerarange);
	float fog_foregrounddepth = camerainversepos.z;
	float diff = min((fog_backgrounddepth-fog_foregrounddepth),opacity);
	//diff *= depthToPosition(gl_FragCoord.z,vec2(camerarange.x,opacity));
	
	//Output
	fragData0 = vec4(fog_color * fog_brightness, diff);
	
	fragData1 = vec4(normalize(ex_normal)*0.5+0.5,fragData0.a);
	fragData1.a = 1/255.0;
	
}
